## passt 0.0~git20251208.e8b56a3

=== debian/changelog ===
passt (0.0~git20251208.e8b56a3-1) unstable; urgency=medium

  * New upstream version 0.0~git20251208.e8b56a3:
    - keep CAP_DAC_OVERRIDE initially (when started as root),
      https://github.com/libguestfs/libguestfs/pull/218
    - don't require global IPv6 address on template interface,
      https://bugs.passt.top/show_bug.cgi?id=122
    - ARP table lookup to preserve MAC addresses from local networks,
      https://bugs.passt.top/show_bug.cgi?id=120
    - fix handling of UDP packets with --freebind,
      https://bugs.passt.top/show_bug.cgi?id=174
    - retry SYN segments on inbound connections,
      https://bugs.passt.top/show_bug.cgi?id=153
    - preserve non-127.0.0.1 loopback address when splice forwarding,
      https://bugs.passt.top/show_bug.cgi?id=113
    - pad inbound frames to 60 bytes (802.3 minimum),
      https://bugs.passt.top/show_bug.cgi?id=166
    - don't let "local mode" enable explicitly disable IP version,
      enable local mode for IPv4 and IP6 separately,
      https://bugs.passt.top/show_bug.cgi?id=128
      https://bugs.passt.top/show_bug.cgi?id=129

 -- Stefano Brivio <sbrivio@redhat.com>  Mon, 08 Dec 2025 15:41:28 +0100

## passt 0.0~git20251209.c3f1ba7

=== debian/changelog ===
passt (0.0~git20251209.c3f1ba7-1) unstable; urgency=medium

  * New upstream version 0.0~git20251209.c3f1ba7: fix potential
    assert on errors for inbound container loopback connections

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 09 Dec 2025 01:38:05 +0100

## passt 0.0~git20251210.d04c480

=== debian/changelog ===
passt (0.0~git20251210.d04c480-1) unstable; urgency=medium

  * New upstream version 0.0~git20251210.d04c480:
    - fix inbound connections to loopback address with IPv6 local mode
      (no IPv6 addresses/routes, but IPv6 enabled),
      https://bugs.passt.top/show_bug.cgi?id=181
    - fix timeout values in trace logs,
      https://bugs.passt.top/show_bug.cgi?id=182

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 10 Dec 2025 14:44:51 +0100

## passt 0.0~git20251215.b40f5cd

=== debian/changelog ===
passt (0.0~git20251215.b40f5cd-1) unstable; urgency=high

  * New upstream version 0.0~git20251215.b40f5cd:
    - fix outbound data transfers when entire sending buffer from the
      kernel is less than the MSS,
      https://bugs.passt.top/show_bug.cgi?id=183 (Closes: #1122950)

 -- Stefano Brivio <sbrivio@redhat.com>  Mon, 15 Dec 2025 10:21:41 +0100

## passt 0.0~git20251223.2ba9fd5

=== debian/changelog ===
passt (0.0~git20251223.2ba9fd5-1) unstable; urgency=medium

  * New upstream version 0.0~git20251223.2ba9fd5:
    - keep pasta running if IPv6 support is disabled in kernel,
      https://bugzilla.redhat.com/show_bug.cgi?id=2424192

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 24 Dec 2025 08:26:53 +0100

## passt 0.0~git20260117.81c97f6

=== debian/changelog ===
passt (0.0~git20260117.81c97f6-1) unstable; urgency=medium

  * New upstream version 0.0~git20260117.81c97f6:
    - add AppArmor rules to access kernel retransmission timeout
      parameters via sysctl,
      https://bugzilla.redhat.com/show_bug.cgi?id=2426863
    - fix busyloop with UDP traffic when vhost-user is not fully
      connected yet, https://bugs.passt.top/show_bug.cgi?id=185
    - follow-up fix for https://bugs.passt.top/show_bug.cgi?id=183,
      improving TCP transfer throughput between nodes with low RTT
    - upgrade AppArmor ABI version to 4.0 and explicitly allow user
      namespace creation in policy, needed when libvirtd calls passt
      as root (Closes: #1124801)

 -- Stefano Brivio <sbrivio@redhat.com>  Sat, 17 Jan 2026 16:32:58 +0100

## passt 0.0~git20260120.386b5f5

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# PASST - Plug A Simple Socket Transport
#  for qemu/UNIX domain socket mode
#
# PASTA - Pack A Subtle Tap Abstraction
#  for network namespace/tap device mode
#
# Copyright (c) 2021 Red Hat GmbH
# Author: Stefano Brivio <sbrivio@redhat.com>

VERSION ?= $(shell git describe --tags HEAD 2>/dev/null || echo "unknown\ version")

# Does the target platform allow IPv4 connections to be handled via
# the IPv6 socket API? (Linux does)
DUAL_STACK_SOCKETS := 1

TARGET ?= $(shell $(CC) -dumpmachine)
$(if $(TARGET),,$(error Failed to get target architecture))
# Get 'uname -m'-like architecture description for target
TARGET_ARCH := $(firstword $(subst -, ,$(TARGET)))
TARGET_ARCH := $(patsubst [:upper:],[:lower:],$(TARGET_ARCH))
TARGET_ARCH := $(patsubst arm%,arm,$(TARGET_ARCH))
TARGET_ARCH := $(subst powerpc,ppc,$(TARGET_ARCH))

# On some systems enabling optimization also enables source fortification,
# automagically. Do not override it.
FORTIFY_FLAG :=
ifeq ($(shell $(CC) -O2 -dM -E - < /dev/null 2>&1 | grep ' _FORTIFY_SOURCE ' > /dev/null; echo $$?),1)
FORTIFY_FLAG := -D_FORTIFY_SOURCE=2
endif

FLAGS := -Wall -Wextra -Wno-format-zero-length -Wformat-security
FLAGS += -pedantic -std=c11 -D_XOPEN_SOURCE=700 -D_GNU_SOURCE
FLAGS +=  $(FORTIFY_FLAG) -O2 -pie -fPIE
FLAGS += -DPAGE_SIZE=$(shell getconf PAGE_SIZE)
FLAGS += -DVERSION=\"$(VERSION)\"
FLAGS += -DDUAL_STACK_SOCKETS=$(DUAL_STACK_SOCKETS)

PASST_SRCS = arch.c arp.c checksum.c conf.c dhcp.c dhcpv6.c epoll_ctl.c \
	flow.c fwd.c icmp.c igmp.c inany.c iov.c ip.c isolation.c lineread.c \
	log.c mld.c ndp.c netlink.c migrate.c packet.c passt.c pasta.c pcap.c \
	pif.c repair.c tap.c tcp.c tcp_buf.c tcp_splice.c tcp_vu.c udp.c \
	udp_flow.c udp_vu.c util.c vhost_user.c virtio.c vu_common.c
QRAP_SRCS = qrap.c
PASST_REPAIR_SRCS = passt-repair.c
SRCS = $(PASST_SRCS) $(QRAP_SRCS) $(PASST_REPAIR_SRCS)

MANPAGES = passt.1 pasta.1 qrap.1 passt-repair.1

PASST_HEADERS = arch.h arp.h checksum.h conf.h dhcp.h dhcpv6.h epoll_ctl.h \
	flow.h fwd.h flow_table.h icmp.h icmp_flow.h inany.h iov.h ip.h \
	isolation.h lineread.h log.h migrate.h ndp.h netlink.h packet.h \
	passt.h pasta.h pcap.h pif.h repair.h siphash.h tap.h tcp.h tcp_buf.h \
	tcp_conn.h tcp_internal.h tcp_splice.h tcp_vu.h udp.h udp_flow.h \
	udp_internal.h udp_vu.h util.h vhost_user.h virtio.h vu_common.h
HEADERS = $(PASST_HEADERS) seccomp.h

C := \#include <sys/random.h>\nint main(){int a=getrandom(0, 0, 0);}
ifeq ($(shell printf "$(C)" | $(CC) -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
	FLAGS += -DHAS_GETRANDOM
endif

ifeq ($(shell :|$(CC) -fstack-protector-strong -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
	FLAGS += -fstack-protector-strong
endif

prefix		?= /usr/local
exec_prefix	?= $(prefix)
bindir		?= $(exec_prefix)/bin
datarootdir	?= $(prefix)/share
docdir		?= $(datarootdir)/doc/passt
mandir		?= $(datarootdir)/man
man1dir		?= $(mandir)/man1

ifeq ($(TARGET_ARCH),x86_64)
BIN := passt passt.avx2 pasta pasta.avx2 qrap passt-repair
else
BIN := passt pasta qrap passt-repair
endif

all: $(BIN) $(MANPAGES) docs

static: FLAGS += -static -DGLIBC_NO_STATIC_NSS
static: clean all

seccomp.h: seccomp.sh $(PASST_SRCS) $(PASST_HEADERS)
	@ EXTRA_SYSCALLS="$(EXTRA_SYSCALLS)" ARCH="$(TARGET_ARCH)" CC="$(CC)" ./seccomp.sh seccomp.h $(PASST_SRCS) $(PASST_HEADERS)

seccomp_repair.h: seccomp.sh $(PASST_REPAIR_SRCS)
	@ ARCH="$(TARGET_ARCH)" CC="$(CC)" ./seccomp.sh seccomp_repair.h $(PASST_REPAIR_SRCS)

passt: $(PASST_SRCS) $(HEADERS)
	$(CC) $(FLAGS) $(CFLAGS) $(CPPFLAGS) $(PASST_SRCS) -o passt $(LDFLAGS)

passt.avx2: FLAGS += -Ofast -mavx2 -ftree-vectorize -funroll-loops
passt.avx2: $(PASST_SRCS) $(HEADERS)
	$(CC) $(filter-out -O2,$(FLAGS)) $(CFLAGS) $(CPPFLAGS) \
		$(PASST_SRCS) -o passt.avx2 $(LDFLAGS)

passt.avx2: passt

pasta.avx2 pasta.1 pasta: pasta%: passt%
	ln -sf $< $@

qrap: $(QRAP_SRCS) passt.h
	$(CC) $(FLAGS) $(CFLAGS) $(CPPFLAGS) -DARCH=\"$(TARGET_ARCH)\" $(QRAP_SRCS) -o qrap $(LDFLAGS)

passt-repair: $(PASST_REPAIR_SRCS) seccomp_repair.h
	$(CC) $(FLAGS) $(CFLAGS) $(CPPFLAGS) $(PASST_REPAIR_SRCS) -o passt-repair $(LDFLAGS)

valgrind: EXTRA_SYSCALLS += rt_sigprocmask rt_sigtimedwait rt_sigaction	\
			    rt_sigreturn getpid gettid kill clock_gettime \
			    mmap|mmap2 munmap open unlink gettimeofday futex \
			    statx readlink
valgrind: FLAGS += -g -DVALGRIND
valgrind: all

.PHONY: clean
clean:
	$(RM) $(BIN) *~ *.o seccomp.h seccomp_repair.h pasta.1 \
		passt.tar passt.tar.gz *.deb *.rpm \
		passt.pid README.plain.md

install: $(BIN) $(MANPAGES) docs
	mkdir -p $(DESTDIR)$(bindir) $(DESTDIR)$(man1dir)
	cp -d $(BIN) $(DESTDIR)$(bindir)
	cp -d $(MANPAGES) $(DESTDIR)$(man1dir)
	mkdir -p $(DESTDIR)$(docdir)
	cp -d README.plain.md $(DESTDIR)$(docdir)/README.md
	cp -d doc/demo.sh $(DESTDIR)$(docdir)

uninstall:
	$(RM) $(BIN:%=$(DESTDIR)$(prefix)/bin/%)
	$(RM) $(MANPAGES:%=$(DESTDIR)$(man1dir)/%)
	$(RM) $(DESTDIR)$(docdir)/README.md
	$(RM) $(DESTDIR)$(docdir)/demo.sh
	-rmdir $(DESTDIR)$(docdir)

pkgs: static
	tar cf passt.tar -P --xform 's//\/usr\/bin\//' $(BIN)
	tar rf passt.tar -P --xform 's//\/usr\/share\/man\/man1\//' \
		$(MANPAGES)
	gzip passt.tar
	EMAIL="sbrivio@redhat.com" fakeroot alien --to-deb \
		--description="User-mode networking for VMs and namespaces" \
		-k --version=$(shell git rev-parse --short HEAD) \
		passt.tar.gz
	fakeroot alien --to-rpm --target=$(shell uname -m) \
		--description="User-mode networking for VMs and namespaces" \
		-k --version=g$(shell git rev-parse --short HEAD) passt.tar.gz

# TODO: This hack makes a "plain" Markdown version of README.md that can be
# reasonably shipped as documentation file, while the current README.md is
# definitely intended for web browser consumption. It should probably work the
# other way around: the web version should be obtained by adding HTML and
# JavaScript portions to a plain Markdown, instead. However, cgit needs to use
# a file in the git tree. Find a better way around this.
docs: README.md
	@(								\
		skip=0;							\
		while read l; do					\
			case $$l in					\
			"## Demo")	exit 0		;;		\
			"<!"*)				;;		\
			"</"*)		skip=1		;;		\
			"<"*)		skip=2		;;		\
			esac;						\
									\
			[ $$skip -eq 0 ]	&& echo "$$l";		\
			[ $$skip -eq 1 ]	&& skip=0;		\
		done < README.md;					\
	) > README.plain.md

clang-tidy: $(PASST_SRCS) $(HEADERS)
	clang-tidy $(PASST_SRCS) -- $(filter-out -pie,$(FLAGS) $(CFLAGS) $(CPPFLAGS)) \
	           -DCLANG_TIDY_58992

cppcheck: $(PASST_SRCS) $(HEADERS)
	if cppcheck --check-level=exhaustive /dev/null > /dev/null 2>&1; then \
		CPPCHECK_EXHAUSTIVE="--check-level=exhaustive";		\
	else								\
		CPPCHECK_EXHAUSTIVE=;					\
	fi;								\
	cppcheck --std=c11 --error-exitcode=1 --enable=all --force	\
	--inconclusive --library=posix --quiet				\
	$${CPPCHECK_EXHAUSTIVE}						\
	--inline-suppr							\
	--suppress=missingIncludeSystem \
	--suppress=unusedStructMember					\
	$(filter -D%,$(FLAGS) $(CFLAGS) $(CPPFLAGS)) -D CPPCHECK_6936  \
	$(PASST_SRCS) $(HEADERS)

=== test/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Tests makefile
#
# Copyright Red Hat
# Author: David Gibson <david@gibson.dropbear.id.au>

BATS = bats -j $(shell nproc)
EXETOOL = exeter/exetool/exetool
WGET = wget -c
FLAKE8 = flake8
MYPY = mypy --strict

DEBIAN_IMGS = debian-8.11.0-openstack-amd64.qcow2 \
	debian-10-nocloud-amd64.qcow2 \
	debian-10-generic-arm64.qcow2 \
	debian-10-generic-ppc64el-20220911-1135.qcow2 \
	debian-11-nocloud-amd64.qcow2 \
	debian-11-generic-arm64.qcow2 \
	debian-11-generic-ppc64el-20250703-2162.qcow2 \
	debian-sid-nocloud-amd64-daily.qcow2 \
	debian-sid-nocloud-arm64-daily.qcow2 \
	debian-sid-nocloud-ppc64el-daily.qcow2

FEDORA_IMGS = Fedora-Cloud-Base-26-1.5.x86_64.qcow2 \
	Fedora-Cloud-Base-27-1.6.x86_64.qcow2 \
	Fedora-Cloud-Base-28-1.1.x86_64.qcow2 \
	Fedora-Cloud-Base-28-1.1.aarch64.qcow2 \
	Fedora-Cloud-Base-29-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-29-1.2.aarch64.qcow2 \
	Fedora-Cloud-Base-30-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-30-1.2.aarch64.qcow2 \
	Fedora-Cloud-Base-31-1.9.x86_64.qcow2 \
	Fedora-Cloud-Base-31-1.9.aarch64.qcow2 \
	Fedora-Cloud-Base-32-1.6.x86_64.qcow2 \
	Fedora-Cloud-Base-32-1.6.aarch64.qcow2 \
	Fedora-Cloud-Base-33-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-33-1.2.aarch64.qcow2 \
	Fedora-Cloud-Base-34-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-34-1.2.aarch64.qcow2 \
	Fedora-Cloud-Base-35-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-35-1.2.aarch64.qcow2

OPENSUSE_IMGS = openSUSE-Leap-15.1-JeOS.x86_64-kvm-and-xen.qcow2 \
	openSUSE-Leap-15.2-JeOS.x86_64-kvm-and-xen.qcow2 \
	openSUSE-Leap-15.3-JeOS.x86_64-kvm-and-xen.qcow2 \
	openSUSE-Tumbleweed-ARM-JeOS-efi.aarch64.raw.xz \
	openSUSE-Tumbleweed-ARM-JeOS-efi.armv7l.raw.xz

UBUNTU_OLD_IMGS = trusty-server-cloudimg-amd64-disk1.img \
	trusty-server-cloudimg-i386-disk1.img \
	trusty-server-cloudimg-ppc64el-disk1.img
UBUNTU_NEW_IMGS = xenial-server-cloudimg-powerpc-disk1.img \
	jammy-server-cloudimg-s390x.img
UBUNTU_IMGS = $(UBUNTU_OLD_IMGS) $(UBUNTU_NEW_IMGS)

DOWNLOAD_ASSETS = $(EXETOOL) mbuto podman \
	$(DEBIAN_IMGS) $(FEDORA_IMGS) $(OPENSUSE_IMGS) $(UBUNTU_IMGS)
TESTDATA_ASSETS = small.bin big.bin medium.bin \
	rampstream
LOCAL_ASSETS = mbuto.img mbuto.mem.img podman/bin/podman QEMU_EFI.fd \
	$(DEBIAN_IMGS:%=prepared-%) $(FEDORA_IMGS:%=prepared-%) \
	$(UBUNTU_NEW_IMGS:%=prepared-%) \
	nstool guest-key guest-key.pub $(TESTDATA_ASSETS)

ASSETS = $(DOWNLOAD_ASSETS) $(LOCAL_ASSETS)

EXETER_PYPATH = exeter/py3
EXETER_PYTHON = build/build.py
EXETER_BATS = smoke/smoke.sh.bats \
	$(EXETER_PYTHON:%=%.bats) build/static_checkers.sh.bats
BATS_FILES = $(EXETER_BATS) \
	podman/test/system/505-networking-pasta.bats

# Python test code (for linters)
PYPKGS = $(EXETER_PYTHON)

CFLAGS = -Wall -Werror -Wextra -pedantic -std=c99

assets: $(ASSETS)

.PHONY: pull-%
pull-%: %
	git -C $* pull

exeter:
	git clone https://gitlab.com/dgibson/exeter.git

exeter/exetool/exetool: pull-exeter

mbuto:
	git clone git://mbuto.sh/mbuto

mbuto/mbuto: pull-mbuto

podman:
	git clone https://github.com/containers/podman.git

# To succesfully build podman, you will need gpgme and systemd
# development packages
podman/bin/podman: pull-podman
	$(MAKE) -C podman

guest-key guest-key.pub:
	ssh-keygen -f guest-key -N ''

mbuto.img: passt.mbuto mbuto/mbuto guest-key.pub rampstream-check.sh $(TESTDATA_ASSETS)
	./mbuto/mbuto -p ./$< -c lz4 -f $@

mbuto.mem.img: passt.mem.mbuto mbuto ../passt.avx2
	./mbuto/mbuto -p ./$< -c lz4 -f $@

nstool: nstool.c
	$(CC) $(CFLAGS) -o $@ $^

QEMU_EFI.fd:
	./find-arm64-firmware.sh $@

prepared-%.qcow2: %.qcow2 ./prepare-distro-img.sh
	qemu-img create -f qcow2 -F qcow2 -b $< $@
	./prepare-distro-img.sh $@

prepared-%.img: %.img ./prepare-distro-img.sh
	qemu-img create -f qcow2 -F qcow2 -b $< $@
	./prepare-distro-img.sh $(IMGTYPE) $@

small.bin:
	dd if=/dev/urandom bs=2k count=1 of=$@

medium.bin:
	dd if=/dev/urandom bs=1k count=5 of=$@

big.bin:
	dd if=/dev/urandom bs=1M count=10 of=$@

flake8: pull-exeter
	PYTHONPATH=$(EXETER_PYPATH) $(FLAKE8) $(PYPKGS)

mypy: pull-exeter
	PYTHONPATH=$(EXETER_PYPATH) $(MYPY) $(PYPKGS)

$(EXETER_BATS): %.bats: % $(EXETOOL)
	PYTHONPATH=$(EXETER_PYPATH) $(EXETOOL) bats -- $< > $@

bats: $(BATS_FILES) pull-podman
	PYTHONPATH=$(EXETER_PYPATH) CONTAINERS_HELPER_BINARY_DIR=.. $(BATS) $(BATS_FILES)

check: assets
	./run

debug: assets
	DEBUG=1 ./run

clean:
	rm -f perf.js *~
	rm -rf .mypy_cache
	rm -f $(LOCAL_ASSETS)
	rm -f $(EXETER_BATS)
	rm -rf test_logs
	rm -f prepared-*.qcow2 prepared-*.img

realclean: clean
	rm -rf $(DOWNLOAD_ASSETS)

# Debian downloads
debian-8.11.0-openstack-%.qcow2:
	-$(WGET) -O $@ https://cloud.debian.org/images/cloud/OpenStack/archive/8.11.0/debian-8.11.0-openstack-$*.qcow2

debian-10-nocloud-%.qcow2:
	-$(WGET) -O $@ https://cloud.debian.org/images/cloud/buster/latest/debian-10-nocloud-$*.qcow2

debian-10-generic-ppc64el-20220911-1135.qcow2:
	-$(WGET) -O $@ https://cloud.debian.org/images/cloud/buster/20220911-1135/debian-10-generic-ppc64el-20220911-1135.qcow2

debian-10-generic-%.qcow2:
	-$(WGET) -O $@ https://cloud.debian.org/images/cloud/buster/latest/debian-10-generic-$*.qcow2

debian-11-nocloud-%.qcow2:
	-$(WGET) -O $@ https://cloud.debian.org/images/cloud/bullseye/latest/debian-11-nocloud-$*.qcow2

debian-11-generic-%.qcow2:
	-$(WGET) -O $@ https://cloud.debian.org/images/cloud/bullseye/latest/debian-11-generic-$*.qcow2

debian-11-generic-ppc64el-20250703-2162.qcow2:
	-$(WGET) -O $@ https://cloud.debian.org/images/cloud/bullseye/20250703-2162/debian-11-generic-ppc64el-20250703-2162.qcow2

debian-sid-nocloud-%-daily.qcow2:
	-$(WGET) -O $@ https://cloud.debian.org/images/cloud/sid/daily/latest/debian-sid-nocloud-$*-daily.qcow2

# Fedora downloads
Fedora-Cloud-Base-26-1.5.%.qcow2:
	-$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/26/CloudImages/$*/images/Fedora-Cloud-Base-26-1.5.$*.qcow2

Fedora-Cloud-Base-27-1.6.%.qcow2:
	-$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/27/CloudImages/$*/images/Fedora-Cloud-Base-27-1.6.$*.qcow2

Fedora-Cloud-Base-28-1.1.%.qcow2:
	-$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/28/Cloud/$*/images/Fedora-Cloud-Base-28-1.1.$*.qcow2

Fedora-Cloud-Base-29-1.2.%.qcow2:
	-$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/29/Cloud/$*/images/Fedora-Cloud-Base-29-1.2.$*.qcow2

Fedora-Cloud-Base-30-1.2.%.qcow2:
	-$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/30/Cloud/$*/images/Fedora-Cloud-Base-30-1.2.$*.qcow2

Fedora-Cloud-Base-31-1.9.%.qcow2:
	-$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/31/Cloud/$*/images/Fedora-Cloud-Base-31-1.9.$*.qcow2

Fedora-Cloud-Base-32-1.6.%.qcow2:
	-$(WGET) -O $@ https://archives.fedoraproject.org/pub/archive/fedora/linux/releases/32/Cloud/$*/images/Fedora-Cloud-Base-32-1.6.$*.qcow2

Fedora-Cloud-Base-33-1.2.%.qcow2:
	-$(WGET) -O $@ https://archives.fedoraproject.org/pub/archive/fedora/linux/releases/33/Cloud/$*/images/Fedora-Cloud-Base-33-1.2.$*.qcow2

Fedora-Cloud-Base-34-1.2.%.qcow2:
	-$(WGET) -O $@ https://archives.fedoraproject.org/pub/archive/fedora/linux/releases/34/Cloud/$*/images/Fedora-Cloud-Base-34-1.2.$*.qcow2

Fedora-Cloud-Base-35-1.2.%.qcow2:
	-$(WGET) -O $@ https://archives.fedoraproject.org/pub/archive/fedora/linux/releases/35/Cloud/$*/images/Fedora-Cloud-Base-35-1.2.$*.qcow2

# OpenSuSE downloads
openSUSE-Leap-15.1-JeOS.x86_64-kvm-and-xen.qcow2:
	-$(WGET) -O $@ https://download.opensuse.org/distribution/leap/15.1/jeos/openSUSE-Leap-15.1-JeOS.x86_64-kvm-and-xen.qcow2

openSUSE-Leap-15.2-JeOS.x86_64-kvm-and-xen.qcow2:
	-$(WGET) -O $@ https://download.opensuse.org/distribution/leap/15.2/appliances/openSUSE-Leap-15.2-JeOS.x86_64-kvm-and-xen.qcow2

openSUSE-Leap-15.3-JeOS.x86_64-kvm-and-xen.qcow2:
	-$(WGET) -O $@ https://download.opensuse.org/distribution/leap/15.3/appliances/openSUSE-Leap-15.3-JeOS.x86_64-kvm-and-xen.qcow2

openSUSE-Tumbleweed-ARM-JeOS-efi.aarch64.raw.xz:
	-$(WGET) -O $@ http://download.opensuse.org/ports/aarch64/tumbleweed/appliances/openSUSE-Tumbleweed-ARM-JeOS-efi.aarch64.raw.xz

openSUSE-Tumbleweed-ARM-JeOS-efi.armv7l.raw.xz:
	-$(WGET) -O $@ http://download.opensuse.org/ports/armv7hl/tumbleweed/appliances/openSUSE-Tumbleweed-ARM-JeOS-efi.armv7l.raw.xz

# Ubuntu downloads
trusty-server-cloudimg-%-disk1.img:
	-$(WGET) -O $@ https://cloud-images.ubuntu.com/trusty/current/trusty-server-cloudimg-$*-disk1.img

xenial-server-cloudimg-powerpc-disk1.img:
	-$(WGET) -O $@ https://cloud-images.ubuntu.com/xenial/current/xenial-server-cloudimg-powerpc-disk1.img

jammy-server-cloudimg-s390x.img:
	-$(WGET) -O $@ https://cloud-images.ubuntu.com/jammy/current/jammy-server-cloudimg-s390x.img

=== debian/changelog ===
passt (0.0~git20260120.386b5f5-1) unstable; urgency=medium

  * control: Update standards version to 4.7.3, drop Priority field
  * New upstream version 0.0~git20260120.386b5f5:
    - introduce implementation of forwarding rules table, which has
      the side effect of fixing Podman container restarts:
      https://github.com/containers/podman/issues/23737
      https://github.com/containers/podman/issues/27634
    - introduce --splice-only option, to forward loopback traffic only

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 20 Jan 2026 22:44:56 +0100

=== debian/control ===
Source: passt
Section: net
Maintainer: Stefano Brivio <sbrivio@redhat.com>
Build-Depends: debhelper-compat (= 13), dh-apparmor
Rules-Requires-Root: no
Standards-Version: 4.7.3
Homepage: https://passt.top/
Vcs-Browser: https://salsa.debian.org/sbrivio/passt
Vcs-Git: https://salsa.debian.org/sbrivio/passt.git

Package: passt
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: apparmor
Description: user-mode networking daemons for virtual machines and namespaces
 passt implements a translation layer between a Layer-2 network interface and
 native Layer-4 sockets (TCP, UDP, ICMP/ICMPv6 echo) on a host. It doesn't
 require any capabilities or privileges, and it can be used as a simple
 replacement for Slirp.
 .
 pasta (same binary as passt, different command) offers equivalent
 functionality, for network namespaces: traffic is forwarded using a tap
 interface inside the namespace, without the need to create further interfaces
 on the host, hence not requiring any capabilities or privileges.

## passt 0.1.0

=== DESCRIPTION ===
Package: passt
Type: Package
Title: Probability Associator Time (PASS-T)
Version: 0.1.0
Authors@R: person("Johannes", "Titz",
                  email = "johannes.titz@gmail.com",
                  role = c("aut", "cre"))
Description: Simulates judgments of frequency and duration based on
    the Probability Associator Time (PASS-T) model. PASS-T is a memory
    model based on a simple competitive artificial neural network. It 
    can imitate human judgments of frequency and duration, which have
    been extensively studied in cognitive psychology
    (e.g. Hintzman (1970) <doi:10.1037/h0028865>, Betsch et al. (2010)
    <https://psycnet.apa.org/record/2010-18204-003>). The PASS-T model
    is an extension of the PASS model (Sedlmeier, 2002,
    ISBN:0198508638). The package provides an easy way to run
    simulations, which can then be compared with empirical data in
    human judgments of frequency and duration.
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 6.1.1
URL: https://github.com/johannes-titz/passt
BugReports: https://github.com/johannes-titz/passt/issues
Suggests: knitr, ggplot2, plyr, testthat (>= 2.1.0), covr
VignetteBuilder: knitr
Imports: magrittr,dplyr,tidyr,rlang
NeedsCompilation: no
Packaged: 2019-11-01 09:17:10 UTC; jt
Author: Johannes Titz [aut, cre]
Maintainer: Johannes Titz <johannes.titz@gmail.com>
Repository: CRAN
Date/Publication: 2019-11-05 10:00:02 UTC

## passt 0.1.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: passt
 Type: Package
 Title: Probability Associator Time (PASS-T)
-Version: 0.1.0
+Version: 0.1.1
 Authors@R: person("Johannes", "Titz",
                   email = "johannes.titz@gmail.com",
                   role = c("aut", "cre"))
@@ -19,15 +19,15 @@
 License: GPL-3
 Encoding: UTF-8
 LazyData: true
-RoxygenNote: 6.1.1
+RoxygenNote: 7.0.2
 URL: https://github.com/johannes-titz/passt
 BugReports: https://github.com/johannes-titz/passt/issues
 Suggests: knitr, ggplot2, plyr, testthat (>= 2.1.0), covr
 VignetteBuilder: knitr
-Imports: magrittr,dplyr,tidyr,rlang
+Imports: magrittr,methods,dplyr,tidyr,rlang
 NeedsCompilation: no
-Packaged: 2019-11-01 09:17:10 UTC; jt
+Packaged: 2019-12-05 13:42:32 UTC; jt
 Author: Johannes Titz [aut, cre]
 Maintainer: Johannes Titz <johannes.titz@gmail.com>
 Repository: CRAN
-Date/Publication: 2019-11-05 10:00:02 UTC
+Date/Publication: 2019-12-05 14:30:02 UTC

## passt 0.1.3

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: passt
 Type: Package
 Title: Probability Associator Time (PASS-T)
-Version: 0.1.1
+Version: 0.1.3
 Authors@R: person("Johannes", "Titz",
                   email = "johannes.titz@gmail.com",
                   role = c("aut", "cre"))
@@ -18,16 +18,16 @@
     human judgments of frequency and duration.
 License: GPL-3
 Encoding: UTF-8
-LazyData: true
 RoxygenNote: 7.0.2
 URL: https://github.com/johannes-titz/passt
 BugReports: https://github.com/johannes-titz/passt/issues
-Suggests: knitr, ggplot2, plyr, testthat (>= 2.1.0), covr
+Suggests: knitr, ggplot2, plyr, testthat (>= 2.1.0), covr, markdown,
+        rmarkdown
 VignetteBuilder: knitr
 Imports: magrittr,methods,dplyr,tidyr,rlang
 NeedsCompilation: no
-Packaged: 2019-12-05 13:42:32 UTC; jt
+Packaged: 2021-05-03 13:50:51 UTC; jt
 Author: Johannes Titz [aut, cre]
 Maintainer: Johannes Titz <johannes.titz@gmail.com>
 Repository: CRAN
-Date/Publication: 2019-12-05 14:30:02 UTC
+Date/Publication: 2021-05-03 14:30:02 UTC
